using System;
using iNTERFACEWARE.Chameleon;
using PrefixTest;

class ServerEngine : PrefixTestEngine
{
   public ServerEngine()
   {
   }
   public override void ParseMessage(string flatwire, Transport aTransport)
   {
      try
      {
         base.ParseMessage(flatwire, aTransport);
      }
      catch (ChameleonException ex)
      {
         ErrorEvent(ex, "Error parsing message");
         //TODO - log the message so it can be analyzed later.
      }
      catch (Exception ex)
      {
          ErrorEvent(ex,"General exception");
         //TODO - log the message so it can be analyzed later.
      }
   }
   public override void OnPatientRegisterMessage(PatientRegisterMessage aMessage, Transport aTransport)
   {
      try
      {
         Println("PatientRegister message parsed with data:");
         Println("LastName:" + aMessage.Patient(0).LastName());
         Println("FirstName:" + aMessage.Patient(0).FirstName());
         Println("Dob:" + aMessage.Patient(0).Dob());
         Println("BirthOrder:" + aMessage.Patient(0).BirthOrder());
         Println("SpeciesCode:" + aMessage.Patient(0).SpeciesCode());
         Println("");
      }
      catch (ChameleonException ex)
      {
         ErrorEvent(ex, "Error in PatientRegister message");
      }
   }
   public override void OnDefaultMessage(DefaultMessage aMessage, Transport aTransport)
   {
      try
      {
         Println("Default message parsed with data:");
         Println("");
      }
      catch (ChameleonException ex)
      {
         ErrorEvent(ex, "Error in Default message");
      }
   }
}
